/* rdbitmap.c */

#include <X11/Xlib.h>    // X-Window 関係のヘッダファイルのインクルード
#include <X11/Xutil.h>   // X-Window 関係のヘッダファイルのインクルード
#include <stdio.h>

int main(void){
  Display     *d;        // Display 構造体
  Window       w;        // ウィンドウ識別子 w
  GC           gc;       // グラフィックス属性 GC 職別子 gc
  Pixmap       bitmap;   // ピックスマップ識別子 bitmap
  XEvent       event;    // XEvent 構造体
  unsigned int width, height;
  int          x_hot, y_hot;

  char fname[20];

  printf("\n*Enter bitmap file name ?");   // bitmap ファイルのファイル名入力
  scanf("%s", fname);

  d = XOpenDisplay(NULL);                  // Display との接続要求
                                           /* Window 生成,位置はルートウィンドの
                                              座標(100,100),大きさ96(幅)x48(高さ),
                                              枠幅:0,枠表示色:黒,ウィンドウ本体:白 */
  w = XCreateSimpleWindow( d, RootWindow(d,0), 100, 100,
			   96, 48, 0, 1, 0);

  XSelectInput ( d, w, ExposureMask );     // Expose イベントを選択するためのマスク指定

  XMapWindow(d, w);                        // Window を可視状態にする

  gc = XCreateGC( d, w, 0, 0 );            // グラフィック属性 GC の要求
  XSetForeground ( d, gc, BlackPixel(d,0) );   // 前景色を黒に指定
  XSetBackground ( d, gc, WhitePixel(d,0) );   // 背景色を白に指定

                                           /* bitmap ファイルを読込む
					      bitmap を生成する*/
  XReadBitmapFile( d, w, fname, &width, &height,
		   &bitmap, &x_hot, &y_hot );

  while (1) {                              // 無限ループに入る
    XNextEvent ( d, &event );              // イベントの取得
    switch ( event.type ) {
    case Expose :
                                           /* Expose イベントのとき、bitmap
					      を Window に複写し、可視にする */
      XCopyPlane( d, bitmap, w, gc,
		  0, 0, width, height, 0, 0, 1 );
      XFlush(d);
    }
  }
  return 0;
}
